POJ3280*Cheapest Palindrome题解动态规划DP

Cheapest Palindrome
Time Limit: 2000MS   Memory Limit: 65536K
Total Submissions: 2620   Accepted: 1294

Description

Keeping track of all the cows can be a tricky task so Farmer John has installed a system to automate it. He has installed on each cow an electronic ID tag that the system will read as the cows pass by a scanner. Each ID tag's contents are currently a single string with length M (1 ≤ M ≤ 2,000) characters drawn from an alphabet of N (1 ≤ N ≤ 26) different symbols (namely, the lower-case roman alphabet).

Cows, being the mischievous creatures they are, sometimes try to spoof the system by walking backwards. While a cow whose ID is "abcba" would read the same no matter which direction the she walks, a cow with the ID "abcb" can potentially register as two different IDs ("abcb" and "bcba").

FJ would like to change the cows's ID tags so they read the same no matter which direction the cow walks by. For example, "abcb" can be changed by adding "a" at the end to form "abcba" so that the ID is palindromic (reads the same forwards and backwards). Some other ways to change the ID to be palindromic are include adding the three letters "bcb" to the begining to yield the ID "bcbabcb" or removing the letter "a" to yield the ID "bcb". One can add or remove characters at any location in the string yielding a string longer or shorter than the original string.

Unfortunately as the ID tags are electronic, each character insertion or deletion has a cost (0 ≤ cost ≤ 10,000) which varies depending on exactly which character value to be added or deleted. Given the content of a cow's ID tag and the cost of inserting or deleting each of the alphabet's characters, find the minimum cost to change the ID tag so it satisfies FJ's requirements. An empty ID tag is considered to satisfy the requirements of reading the same forward and backward. Only letters with associated costs can be added to a string.

Input

Line 1: Two space-separated integers: N and M
Line 2: This line contains exactly M characters which constitute the initial ID string
Lines 3.. N+2: Each line contains three space-separated entities: a character of the input alphabet and two integers which are respectively the cost of adding and deleting that character.

Output

Line 1: A single line with a single integer that is the minimum cost to change the given name tag.

Sample Input

3 4
abcb
a 1000 1100
b 350 700
c 200 800

Sample Output

900

Hint

If we insert an "a" on the end to get "abcba", the cost would be 1000. If we delete the "a" on the beginning to get "bcb", the cost would be 1100. If we insert "bcb" at the begining of the string, the cost would be 350 + 200 + 350 = 900, which is the minimum.

Source

USACO 2007 Open Gold
经典的括号模型竟然没看出来
删除某个字符和在对应镜像位置增加这个字符效果相同,所以只用保留删除、增加花费最小值
状态:
d[i][j]表示从第i个字符到第j个字符最小花费
状态转移方程:
d[i][j]=min(d[i+1][j]+cost[s[i]],d[i][j-1]+cost[s[j]])
if(s[i]==s[j])
d[i][j]=min(d[i][j],d[i+1][j-1])
边界:
d[i][j]=inf (j>i)
d[i][i]=0
代码:
#include<cstdio> #define min(a,b) ((a)<(b)?(a):(b)) int d[2005][2005],x[256],i,j,p,n,m; int main() { char s[2005],c; scanf("%d%d%s",&n,&m,s+1); for(i=1;i<=n;i++) { scanf(" %c %d%d",&c,&j,&p); x[c]=min(j,p); } for(p=1;p<m;p++) for(i=1;i+p<=m;i++) { d[i][j=i+p]=-1u>>1; d[i][j]=min(d[i+1][j]+x[s[i]],d[i][j-1]+x[s[j]]); if(s[i]==s[j]) d[i][j]=min(d[i][j],d[i+1][j-1]); } printf("%d/n",d[1][m]); }
附USACO题解
USACO OPEN07 Problem 'cheappal' Analysis
by Richard Peng
This problem can be done using dynamic programming (DP). First observe that the cost of inserting/removing characters can be combined into one cost since inserting another of of the same character at the mirrored poisition would have the same effect as deleting the character. So we can left cost[ch] be the minimum of the two costs for inserting/deleting character ch.

Now consider the dp state of [l,r] which represents a substring. For each state, we try to minimize the cost of changing that substring into a palindrome. Then the state transition function would be:

DP[l,r]=min{DP[l+1,r]+cost[s[l]]. ('pair up' left most character)
DP[l,r+1]+cost[s[r]], ('pair up' right most character)
DP[l+1,r-1] (only if the two end characters are equal, aka. s[l]=s[r]}

The state transition takes O(1) time while there are a total of O(M^2) states. So the algorithm runs in O(M^2) time.

Test Data

All data were generated randomly while specifying N and M.
It's intended that a brute-force search would get cases 1-4, anything O(M^3) or faster would get cases 1-8 while the O(M^2) solution is required to get full points.

Below is the solution of China's Yang Yi:


#include <stdio.h>
#define MAXN 2001

FILE *in = fopen("cheappal.in","r");
FILE *out = fopen("cheappal.out","w");

int n, m, is[26], de[26], dp[MAXN][MAXN];
char str[MAXN + 1];

int main () {
    int i, j, a, b;
    char ch;
    
    fscanf (in, "%d%d%s", &n, &m, str);
    for (i = 0; i < n; i ++) {
        do fscanf(in,"%c",&ch);
            while (ch <= ' ');
        fscanf(in,"%d%d",&a,&b);
        is[ch - 'a'] = a;
        de[ch - 'a'] = b;
        }
    for (a = 0; a < m; a ++)
        for (i = 0; i + a < m; i ++) {
            j = i + a;
            if (i == j || i + 1 == j && str[i] == str[j])
                dp[i][j] = 0;
            else {
                dp[i][j] = (dp[i+1][j] + (is[str[i]-'a'] <? de[str[i]-'a'])) <? (dp[i][j-1] + (is[str[j]-'a'] <? de[str[j]-'a']));
                if (str[i] == str[j])
                    dp[i][j] <?= dp[i+1][j-1];
                }
            }
    fprintf(out,"%d/n",dp[0][m - 1]);
    fclose(in);
    fclose(out);
    return 0;
}

你可能感兴趣的:(POJ3280*Cheapest Palindrome题解动态规划DP)